<?php
/**
 * Registro9CNABSantander
 *
 * @package    Logic
 * @subpackage Registro/Cnab
 *
 * @author     thalesvalias - 30/07/2012
 *
 */
class Registro9CNABSantander extends RegistroCNAB{

    const REGISTRO_9 = '9';
    const LOTE_SERVICO_REGISTRO_9 = '9999';


    /**
     * Gera Tipo de Registro 9 - Registro Trailer de Arquivo.
     *
     * @return void
     *
     * @author thalesvalias - 30/07/2012
     */
    public function geraRegistro9(){
        $this->_geraRegistro();
    }


    /**
     * Atribui os dados no atributo da classe Pai.
     *
     * @return void
     *
     * @author thalesvalias - 30/07/2012
     */
    private function _geraRegistro(){
        // Bloco 1 ao 3 eh gerado no pai.
        parent::geraRegistro(self::REGISTRO_9, CNABSantander::CODIGO_BANCO_SANTANDER, self::LOTE_SERVICO_REGISTRO_9);

        // Bloco 4 | 009-017 | Filler (Caracter branco).
        $this->atribuiDado(parent::CARACTER_BRANCO, 9, parent::CARACTER_BRANCO, parent::PREENCHE_DIREITA);

        // Bloco 5 | 018-023 | Quantidade de lotes do arquivo (Registros Tipo 1).
        // Calculado apos a geracao de todos os registros do arquivo (a linha eh modificada no PercorreCaged).
        $this->atribuiDado(parent::CARACTER_ZERO, 6, parent::CARACTER_ZERO, parent::PREENCHE_ESQUERDA);

        // Bloco 6 | 024-029 | Quantidade de registros no arquivo (Registros Tipo 0, 1, 3, 5 e 9).
        // Calculado apos a geracao de todos os registros do arquivo (a linha eh modificada no PercorreCaged).
        $this->atribuiDado(parent::CARACTER_ZERO, 6, parent::CARACTER_ZERO, parent::PREENCHE_ESQUERDA);

        // Bloco 7 | 030-240 | Filler.
        $this->atribuiDado(parent::CARACTER_BRANCO, 211, parent::CARACTER_BRANCO, parent::PREENCHE_DIREITA);
    }


}