<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class GpeSolicitacao extends \Doctrine\ORM\EntityRepository {

    public function getInfoFase($nrorg, $nrsolicitacao) {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();

        $sql = <<<SQL
SELECT
    S.NRORG,
    S.NRSOLICITACAO,
    S.NRTIPOSOLICITACAO,
    T.NRMODELOAPROVSOLI,
    FASE_TRAM_ATUAL.NRFASETRAMSOLI NRFASETRAMSOLI_ATUAL,
    FASE_TRAM_ATUAL.IDAPROVADO IDAPROVADO_ATUAL,
    CASE
        WHEN FASE_SEGUINTE.NRFASEAPROVSOLI IS NOT NULL
            AND (FASE_TRAM_ATUAL.IDAPROVADO = 'S' OR (FASE_TRAM_ATUAL.IDAPROVADO = 'N' AND FASE_ATUAL.IDFASEOBRIGATORIA = 'N') OR FASE_TRAM_ATUAL.NRFASETRAMSOLI IS NULL)
            AND S.IDAPROVACAOSEC NOT IN ('R', 'A') THEN 'S'
        ELSE 'N'
    END FASE_ATUAL_VALIDA_APROVACAO,
    FASE_TRAM_ATUAL.DSOBSERVACAO DSOBSERVACAO_ATUAL,
    FASE_SEGUINTE.NRFASEAPROVSOLI NRFASEAPROVSOLI_SEGUINTE,
    FASE_SEGUINTE.NRORDEM NRORDEM_SEGUINTE,
    FASE_SEGUINTE.IDFASEOBRIGATORIA IDFASEOBRIGATORIA_SEGUINTE,
    CASE
        WHEN FASE_SEGUINTE.NRFASEAPROVSOLI IS NULL THEN 'N'
        ELSE 'S'
    END EXISTE_FASE_SEGUINTE,
    CASE
        WHEN FASE_SEGUINTE.NRFASEAPROVSOLI = ULTIMA_FASE.NRFASEAPROVSOLI THEN 'S'
        ELSE 'N'
    END FASE_ATUAL_EH_ULTIMA
FROM GPE_SOLICITACAO S
JOIN GPE_PERFACESTIPOSOLI T ON T.NRORG = S.NRORG
    AND T.NRTIPOSOLICITACAO = S.NRTIPOSOLICITACAO
JOIN GPE_MODELOAPROVSOLI M ON M.NRORG = S.NRORG
    AND M.NRMODELOAPROVSOLI = T.NRMODELOAPROVSOLI
LEFT JOIN GPE_FASETRAMSOLI FASE_TRAM_ATUAL ON FASE_TRAM_ATUAL.NRORG = S.NRORG
    AND FASE_TRAM_ATUAL.NRSOLICITACAO = S.NRSOLICITACAO
    AND FASE_TRAM_ATUAL.NRFASEAPROVSOLI = (
        SELECT F2.NRFASEAPROVSOLI
        FROM GPE_FASETRAMSOLI F2
        LEFT JOIN GPE_FASEAPROVSOLI FA2 ON FA2.NRORG = F2.NRORG
            AND FA2.NRFASEAPROVSOLI = F2.NRFASEAPROVSOLI
        WHERE F2.NRORG = FASE_TRAM_ATUAL.NRORG
            AND F2.NRSOLICITACAO = FASE_TRAM_ATUAL.NRSOLICITACAO
        ORDER BY FA2.NRORDEM DESC
        FETCH FIRST ROW ONLY
    )
LEFT JOIN GPE_FASEAPROVSOLI FASE_ATUAL ON FASE_ATUAL.NRORG = S.NRORG
    AND FASE_ATUAL.NRFASEAPROVSOLI = FASE_TRAM_ATUAL.NRFASEAPROVSOLI
LEFT JOIN GPE_FASEAPROVSOLI FASE_SEGUINTE ON FASE_SEGUINTE.NRORG = S.NRORG
    AND FASE_SEGUINTE.NRMODELOAPROVSOLI = T.NRMODELOAPROVSOLI
    AND FASE_SEGUINTE.NRORDEM = (
        SELECT MIN(NRORDEM)
        FROM GPE_FASEAPROVSOLI
        WHERE NRORG = FASE_SEGUINTE.NRORG
            AND NRMODELOAPROVSOLI = FASE_SEGUINTE.NRMODELOAPROVSOLI
            AND NRFASEAPROVSOLI > NVL(FASE_TRAM_ATUAL.NRFASEAPROVSOLI, -1)
    )
LEFT JOIN GPE_FASEAPROVSOLI ULTIMA_FASE ON ULTIMA_FASE.NRORG = S.NRORG
    AND ULTIMA_FASE.NRMODELOAPROVSOLI = T.NRMODELOAPROVSOLI
    AND ULTIMA_FASE.NRORDEM = (
        SELECT MAX(NRORDEM)
        FROM GPE_FASEAPROVSOLI
        WHERE NRORG = ULTIMA_FASE.NRORG
            AND NRMODELOAPROVSOLI = ULTIMA_FASE.NRMODELOAPROVSOLI
    )
WHERE S.NRORG = :P_NRORG
    AND S.NRSOLICITACAO = :P_NRSOLICITACAO
SQL;

        $params = array(
            'P_NRORG' => $nrorg,
            'P_NRSOLICITACAO' => $nrsolicitacao
        );

        return $db->fetchAssoc($sql, $params);
    }
}